# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220421


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class UsageDataDetails(object):
    """
    The source details of the usage data in object storage. The usage data file uploaded to object storage must be a gzip archive
    of the JSON usage data returned from the GraalVM native-image-inspect tool after a native-image build.
    Set `sourceType` to `objectStorageTuple`
    and use :func:`usage_data_via_object_storage_tuple_details`
    when specifying the namespace, bucket name, and object name.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new UsageDataDetails object with values from keyword arguments. This class has the following subclasses and if you are using this class as input
        to a service operations then you should favor using a subclass over the base class:

        * :class:`~oci.adm.models.UsageDataViaObjectStorageTupleDetails`

        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param source_type:
            The value to assign to the source_type property of this UsageDataDetails.
        :type source_type: str

        """
        self.swagger_types = {
            'source_type': 'str'
        }

        self.attribute_map = {
            'source_type': 'sourceType'
        }

        self._source_type = None

    @staticmethod
    def get_subtype(object_dictionary):
        """
        Given the hash representation of a subtype of this class,
        use the info in the hash to return the class of the subtype.
        """
        type = object_dictionary['sourceType']

        if type == 'objectStorageTuple':
            return 'UsageDataViaObjectStorageTupleDetails'
        else:
            return 'UsageDataDetails'

    @property
    def source_type(self):
        """
        **[Required]** Gets the source_type of this UsageDataDetails.
        The destination type. Use `objectStorageTuple` when specifying the namespace, bucket name, and object name.


        :return: The source_type of this UsageDataDetails.
        :rtype: str
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """
        Sets the source_type of this UsageDataDetails.
        The destination type. Use `objectStorageTuple` when specifying the namespace, bucket name, and object name.


        :param source_type: The source_type of this UsageDataDetails.
        :type: str
        """
        self._source_type = source_type

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
