# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630

from __future__ import absolute_import

from .aggregate_network_data_details import AggregateNetworkDataDetails
from .aggregated_network_data import AggregatedNetworkData
from .aggregated_network_data_result import AggregatedNetworkDataResult
from .availability_configuration import AvailabilityConfiguration
from .available_capability import AvailableCapability
from .basic_authentication_details import BasicAuthenticationDetails
from .browser_monitor_configuration import BrowserMonitorConfiguration
from .client_certificate import ClientCertificate
from .client_certificate_details import ClientCertificateDetails
from .create_dedicated_vantage_point_details import CreateDedicatedVantagePointDetails
from .create_monitor_details import CreateMonitorDetails
from .create_on_premise_vantage_point_details import CreateOnPremiseVantagePointDetails
from .create_script_details import CreateScriptDetails
from .create_worker_details import CreateWorkerDetails
from .database_wallet_details import DatabaseWalletDetails
from .dedicated_vantage_point import DedicatedVantagePoint
from .dedicated_vantage_point_collection import DedicatedVantagePointCollection
from .dedicated_vantage_point_summary import DedicatedVantagePointSummary
from .dns_configuration import DnsConfiguration
from .dns_sec_monitor_configuration import DnsSecMonitorConfiguration
from .dns_server_monitor_configuration import DnsServerMonitorConfiguration
from .dns_trace_monitor_configuration import DnsTraceMonitorConfiguration
from .dvp_stack_details import DvpStackDetails
from .ftp_monitor_configuration import FtpMonitorConfiguration
from .geo_summary import GeoSummary
from .header import Header
from .identity_info_details import IdentityInfoDetails
from .link import Link
from .maintenance_window_schedule import MaintenanceWindowSchedule
from .monitor import Monitor
from .monitor_collection import MonitorCollection
from .monitor_configuration import MonitorConfiguration
from .monitor_result import MonitorResult
from .monitor_result_data import MonitorResultData
from .monitor_script_parameter import MonitorScriptParameter
from .monitor_script_parameter_info import MonitorScriptParameterInfo
from .monitor_status_count_map import MonitorStatusCountMap
from .monitor_summary import MonitorSummary
from .network_configuration import NetworkConfiguration
from .network_monitor_configuration import NetworkMonitorConfiguration
from .node import Node
from .on_premise_vantage_point import OnPremiseVantagePoint
from .on_premise_vantage_point_collection import OnPremiseVantagePointCollection
from .on_premise_vantage_point_summary import OnPremiseVantagePointSummary
from .on_premise_vp_worker_version_details import OnPremiseVpWorkerVersionDetails
from .oracle_rm_stack import OracleRMStack
from .password import Password
from .password_in_text import PasswordInText
from .password_in_vault import PasswordInVault
from .private_key import PrivateKey
from .public_vantage_point_collection import PublicVantagePointCollection
from .public_vantage_point_summary import PublicVantagePointSummary
from .request_authentication_details import RequestAuthenticationDetails
from .request_query_param import RequestQueryParam
from .rest_monitor_configuration import RestMonitorConfiguration
from .script import Script
from .script_collection import ScriptCollection
from .script_parameter import ScriptParameter
from .script_parameter_info import ScriptParameterInfo
from .script_summary import ScriptSummary
from .scripted_browser_monitor_configuration import ScriptedBrowserMonitorConfiguration
from .scripted_rest_monitor_configuration import ScriptedRestMonitorConfiguration
from .sql_monitor_configuration import SqlMonitorConfiguration
from .update_dedicated_vantage_point_details import UpdateDedicatedVantagePointDetails
from .update_monitor_details import UpdateMonitorDetails
from .update_on_premise_vantage_point_details import UpdateOnPremiseVantagePointDetails
from .update_script_details import UpdateScriptDetails
from .update_worker_details import UpdateWorkerDetails
from .vantage_point_execution import VantagePointExecution
from .vantage_point_info import VantagePointInfo
from .vantage_point_node import VantagePointNode
from .verify_text import VerifyText
from .worker import Worker
from .worker_collection import WorkerCollection
from .worker_monitor_list import WorkerMonitorList
from .worker_summary import WorkerSummary
from .workers_summary import WorkersSummary

# Maps type names to classes for apm_synthetics services.
apm_synthetics_type_mapping = {
    "AggregateNetworkDataDetails": AggregateNetworkDataDetails,
    "AggregatedNetworkData": AggregatedNetworkData,
    "AggregatedNetworkDataResult": AggregatedNetworkDataResult,
    "AvailabilityConfiguration": AvailabilityConfiguration,
    "AvailableCapability": AvailableCapability,
    "BasicAuthenticationDetails": BasicAuthenticationDetails,
    "BrowserMonitorConfiguration": BrowserMonitorConfiguration,
    "ClientCertificate": ClientCertificate,
    "ClientCertificateDetails": ClientCertificateDetails,
    "CreateDedicatedVantagePointDetails": CreateDedicatedVantagePointDetails,
    "CreateMonitorDetails": CreateMonitorDetails,
    "CreateOnPremiseVantagePointDetails": CreateOnPremiseVantagePointDetails,
    "CreateScriptDetails": CreateScriptDetails,
    "CreateWorkerDetails": CreateWorkerDetails,
    "DatabaseWalletDetails": DatabaseWalletDetails,
    "DedicatedVantagePoint": DedicatedVantagePoint,
    "DedicatedVantagePointCollection": DedicatedVantagePointCollection,
    "DedicatedVantagePointSummary": DedicatedVantagePointSummary,
    "DnsConfiguration": DnsConfiguration,
    "DnsSecMonitorConfiguration": DnsSecMonitorConfiguration,
    "DnsServerMonitorConfiguration": DnsServerMonitorConfiguration,
    "DnsTraceMonitorConfiguration": DnsTraceMonitorConfiguration,
    "DvpStackDetails": DvpStackDetails,
    "FtpMonitorConfiguration": FtpMonitorConfiguration,
    "GeoSummary": GeoSummary,
    "Header": Header,
    "IdentityInfoDetails": IdentityInfoDetails,
    "Link": Link,
    "MaintenanceWindowSchedule": MaintenanceWindowSchedule,
    "Monitor": Monitor,
    "MonitorCollection": MonitorCollection,
    "MonitorConfiguration": MonitorConfiguration,
    "MonitorResult": MonitorResult,
    "MonitorResultData": MonitorResultData,
    "MonitorScriptParameter": MonitorScriptParameter,
    "MonitorScriptParameterInfo": MonitorScriptParameterInfo,
    "MonitorStatusCountMap": MonitorStatusCountMap,
    "MonitorSummary": MonitorSummary,
    "NetworkConfiguration": NetworkConfiguration,
    "NetworkMonitorConfiguration": NetworkMonitorConfiguration,
    "Node": Node,
    "OnPremiseVantagePoint": OnPremiseVantagePoint,
    "OnPremiseVantagePointCollection": OnPremiseVantagePointCollection,
    "OnPremiseVantagePointSummary": OnPremiseVantagePointSummary,
    "OnPremiseVpWorkerVersionDetails": OnPremiseVpWorkerVersionDetails,
    "OracleRMStack": OracleRMStack,
    "Password": Password,
    "PasswordInText": PasswordInText,
    "PasswordInVault": PasswordInVault,
    "PrivateKey": PrivateKey,
    "PublicVantagePointCollection": PublicVantagePointCollection,
    "PublicVantagePointSummary": PublicVantagePointSummary,
    "RequestAuthenticationDetails": RequestAuthenticationDetails,
    "RequestQueryParam": RequestQueryParam,
    "RestMonitorConfiguration": RestMonitorConfiguration,
    "Script": Script,
    "ScriptCollection": ScriptCollection,
    "ScriptParameter": ScriptParameter,
    "ScriptParameterInfo": ScriptParameterInfo,
    "ScriptSummary": ScriptSummary,
    "ScriptedBrowserMonitorConfiguration": ScriptedBrowserMonitorConfiguration,
    "ScriptedRestMonitorConfiguration": ScriptedRestMonitorConfiguration,
    "SqlMonitorConfiguration": SqlMonitorConfiguration,
    "UpdateDedicatedVantagePointDetails": UpdateDedicatedVantagePointDetails,
    "UpdateMonitorDetails": UpdateMonitorDetails,
    "UpdateOnPremiseVantagePointDetails": UpdateOnPremiseVantagePointDetails,
    "UpdateScriptDetails": UpdateScriptDetails,
    "UpdateWorkerDetails": UpdateWorkerDetails,
    "VantagePointExecution": VantagePointExecution,
    "VantagePointInfo": VantagePointInfo,
    "VantagePointNode": VantagePointNode,
    "VerifyText": VerifyText,
    "Worker": Worker,
    "WorkerCollection": WorkerCollection,
    "WorkerMonitorList": WorkerMonitorList,
    "WorkerSummary": WorkerSummary,
    "WorkersSummary": WorkersSummary
}
