# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20160918


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CapacityReportInstanceShapeConfig(object):
    """
    The shape configuration for a shape in a capacity report.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new CapacityReportInstanceShapeConfig object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param ocpus:
            The value to assign to the ocpus property of this CapacityReportInstanceShapeConfig.
        :type ocpus: float

        :param memory_in_gbs:
            The value to assign to the memory_in_gbs property of this CapacityReportInstanceShapeConfig.
        :type memory_in_gbs: float

        :param nvmes:
            The value to assign to the nvmes property of this CapacityReportInstanceShapeConfig.
        :type nvmes: int

        """
        self.swagger_types = {
            'ocpus': 'float',
            'memory_in_gbs': 'float',
            'nvmes': 'int'
        }

        self.attribute_map = {
            'ocpus': 'ocpus',
            'memory_in_gbs': 'memoryInGBs',
            'nvmes': 'nvmes'
        }

        self._ocpus = None
        self._memory_in_gbs = None
        self._nvmes = None

    @property
    def ocpus(self):
        """
        Gets the ocpus of this CapacityReportInstanceShapeConfig.
        The total number of OCPUs available to the instance.


        :return: The ocpus of this CapacityReportInstanceShapeConfig.
        :rtype: float
        """
        return self._ocpus

    @ocpus.setter
    def ocpus(self, ocpus):
        """
        Sets the ocpus of this CapacityReportInstanceShapeConfig.
        The total number of OCPUs available to the instance.


        :param ocpus: The ocpus of this CapacityReportInstanceShapeConfig.
        :type: float
        """
        self._ocpus = ocpus

    @property
    def memory_in_gbs(self):
        """
        Gets the memory_in_gbs of this CapacityReportInstanceShapeConfig.
        The total amount of memory available to the instance, in gigabytes.


        :return: The memory_in_gbs of this CapacityReportInstanceShapeConfig.
        :rtype: float
        """
        return self._memory_in_gbs

    @memory_in_gbs.setter
    def memory_in_gbs(self, memory_in_gbs):
        """
        Sets the memory_in_gbs of this CapacityReportInstanceShapeConfig.
        The total amount of memory available to the instance, in gigabytes.


        :param memory_in_gbs: The memory_in_gbs of this CapacityReportInstanceShapeConfig.
        :type: float
        """
        self._memory_in_gbs = memory_in_gbs

    @property
    def nvmes(self):
        """
        Gets the nvmes of this CapacityReportInstanceShapeConfig.
        The number of NVMe drives to be used for storage.


        :return: The nvmes of this CapacityReportInstanceShapeConfig.
        :rtype: int
        """
        return self._nvmes

    @nvmes.setter
    def nvmes(self, nvmes):
        """
        Sets the nvmes of this CapacityReportInstanceShapeConfig.
        The number of NVMe drives to be used for storage.


        :param nvmes: The nvmes of this CapacityReportInstanceShapeConfig.
        :type: int
        """
        self._nvmes = nvmes

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
