# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: release

from __future__ import absolute_import

from .auto_key_rotation_details import AutoKeyRotationDetails
from .backup_key_details import BackupKeyDetails
from .backup_location import BackupLocation
from .backup_location_bucket import BackupLocationBucket
from .backup_location_uri import BackupLocationURI
from .backup_vault_details import BackupVaultDetails
from .change_hsm_cluster_compartment_details import ChangeHsmClusterCompartmentDetails
from .change_key_compartment_details import ChangeKeyCompartmentDetails
from .change_vault_compartment_details import ChangeVaultCompartmentDetails
from .create_ekms_private_endpoint_details import CreateEkmsPrivateEndpointDetails
from .create_hsm_cluster_details import CreateHsmClusterDetails
from .create_key_details import CreateKeyDetails
from .create_vault_details import CreateVaultDetails
from .create_vault_replica_details import CreateVaultReplicaDetails
from .decrypt_data_details import DecryptDataDetails
from .decrypted_data import DecryptedData
from .delete_vault_replica_details import DeleteVaultReplicaDetails
from .ekms_private_endpoint import EkmsPrivateEndpoint
from .ekms_private_endpoint_summary import EkmsPrivateEndpointSummary
from .encrypt_data_details import EncryptDataDetails
from .encrypted_data import EncryptedData
from .export_key_details import ExportKeyDetails
from .exported_key_data import ExportedKeyData
from .external_key_manager_metadata import ExternalKeyManagerMetadata
from .external_key_manager_metadata_summary import ExternalKeyManagerMetadataSummary
from .external_key_reference import ExternalKeyReference
from .external_key_reference_details import ExternalKeyReferenceDetails
from .external_key_version_reference import ExternalKeyVersionReference
from .generate_key_details import GenerateKeyDetails
from .generated_key import GeneratedKey
from .hsm_cluster import HsmCluster
from .hsm_cluster_collection import HsmClusterCollection
from .hsm_cluster_summary import HsmClusterSummary
from .hsm_partition import HsmPartition
from .hsm_partition_collection import HsmPartitionCollection
from .hsm_partition_summary import HsmPartitionSummary
from .import_key_details import ImportKeyDetails
from .import_key_version_details import ImportKeyVersionDetails
from .key import Key
from .key_replica_details import KeyReplicaDetails
from .key_shape import KeyShape
from .key_summary import KeySummary
from .key_version import KeyVersion
from .key_version_replica_details import KeyVersionReplicaDetails
from .key_version_summary import KeyVersionSummary
from .oauth_metadata import OauthMetadata
from .oauth_metadata_summary import OauthMetadataSummary
from .port_information import PortInformation
from .pre_co_user_credentials import PreCoUserCredentials
from .replica_details import ReplicaDetails
from .replication_status_details import ReplicationStatusDetails
from .restore_key_from_object_store_details import RestoreKeyFromObjectStoreDetails
from .restore_vault_from_object_store_details import RestoreVaultFromObjectStoreDetails
from .schedule_hsm_cluster_deletion_details import ScheduleHsmClusterDeletionDetails
from .schedule_key_deletion_details import ScheduleKeyDeletionDetails
from .schedule_key_version_deletion_details import ScheduleKeyVersionDeletionDetails
from .schedule_vault_deletion_details import ScheduleVaultDeletionDetails
from .sign_data_details import SignDataDetails
from .signed_data import SignedData
from .update_ekms_private_endpoint_details import UpdateEkmsPrivateEndpointDetails
from .update_hsm_cluster_details import UpdateHsmClusterDetails
from .update_key_details import UpdateKeyDetails
from .update_vault_details import UpdateVaultDetails
from .upload_partition_certificates_details import UploadPartitionCertificatesDetails
from .vault import Vault
from .vault_replica_details import VaultReplicaDetails
from .vault_replica_summary import VaultReplicaSummary
from .vault_summary import VaultSummary
from .vault_usage import VaultUsage
from .verified_data import VerifiedData
from .verify_data_details import VerifyDataDetails
from .wrapped_import_key import WrappedImportKey
from .wrapping_key import WrappingKey

# Maps type names to classes for key_management services.
key_management_type_mapping = {
    "AutoKeyRotationDetails": AutoKeyRotationDetails,
    "BackupKeyDetails": BackupKeyDetails,
    "BackupLocation": BackupLocation,
    "BackupLocationBucket": BackupLocationBucket,
    "BackupLocationURI": BackupLocationURI,
    "BackupVaultDetails": BackupVaultDetails,
    "ChangeHsmClusterCompartmentDetails": ChangeHsmClusterCompartmentDetails,
    "ChangeKeyCompartmentDetails": ChangeKeyCompartmentDetails,
    "ChangeVaultCompartmentDetails": ChangeVaultCompartmentDetails,
    "CreateEkmsPrivateEndpointDetails": CreateEkmsPrivateEndpointDetails,
    "CreateHsmClusterDetails": CreateHsmClusterDetails,
    "CreateKeyDetails": CreateKeyDetails,
    "CreateVaultDetails": CreateVaultDetails,
    "CreateVaultReplicaDetails": CreateVaultReplicaDetails,
    "DecryptDataDetails": DecryptDataDetails,
    "DecryptedData": DecryptedData,
    "DeleteVaultReplicaDetails": DeleteVaultReplicaDetails,
    "EkmsPrivateEndpoint": EkmsPrivateEndpoint,
    "EkmsPrivateEndpointSummary": EkmsPrivateEndpointSummary,
    "EncryptDataDetails": EncryptDataDetails,
    "EncryptedData": EncryptedData,
    "ExportKeyDetails": ExportKeyDetails,
    "ExportedKeyData": ExportedKeyData,
    "ExternalKeyManagerMetadata": ExternalKeyManagerMetadata,
    "ExternalKeyManagerMetadataSummary": ExternalKeyManagerMetadataSummary,
    "ExternalKeyReference": ExternalKeyReference,
    "ExternalKeyReferenceDetails": ExternalKeyReferenceDetails,
    "ExternalKeyVersionReference": ExternalKeyVersionReference,
    "GenerateKeyDetails": GenerateKeyDetails,
    "GeneratedKey": GeneratedKey,
    "HsmCluster": HsmCluster,
    "HsmClusterCollection": HsmClusterCollection,
    "HsmClusterSummary": HsmClusterSummary,
    "HsmPartition": HsmPartition,
    "HsmPartitionCollection": HsmPartitionCollection,
    "HsmPartitionSummary": HsmPartitionSummary,
    "ImportKeyDetails": ImportKeyDetails,
    "ImportKeyVersionDetails": ImportKeyVersionDetails,
    "Key": Key,
    "KeyReplicaDetails": KeyReplicaDetails,
    "KeyShape": KeyShape,
    "KeySummary": KeySummary,
    "KeyVersion": KeyVersion,
    "KeyVersionReplicaDetails": KeyVersionReplicaDetails,
    "KeyVersionSummary": KeyVersionSummary,
    "OauthMetadata": OauthMetadata,
    "OauthMetadataSummary": OauthMetadataSummary,
    "PortInformation": PortInformation,
    "PreCoUserCredentials": PreCoUserCredentials,
    "ReplicaDetails": ReplicaDetails,
    "ReplicationStatusDetails": ReplicationStatusDetails,
    "RestoreKeyFromObjectStoreDetails": RestoreKeyFromObjectStoreDetails,
    "RestoreVaultFromObjectStoreDetails": RestoreVaultFromObjectStoreDetails,
    "ScheduleHsmClusterDeletionDetails": ScheduleHsmClusterDeletionDetails,
    "ScheduleKeyDeletionDetails": ScheduleKeyDeletionDetails,
    "ScheduleKeyVersionDeletionDetails": ScheduleKeyVersionDeletionDetails,
    "ScheduleVaultDeletionDetails": ScheduleVaultDeletionDetails,
    "SignDataDetails": SignDataDetails,
    "SignedData": SignedData,
    "UpdateEkmsPrivateEndpointDetails": UpdateEkmsPrivateEndpointDetails,
    "UpdateHsmClusterDetails": UpdateHsmClusterDetails,
    "UpdateKeyDetails": UpdateKeyDetails,
    "UpdateVaultDetails": UpdateVaultDetails,
    "UploadPartitionCertificatesDetails": UploadPartitionCertificatesDetails,
    "Vault": Vault,
    "VaultReplicaDetails": VaultReplicaDetails,
    "VaultReplicaSummary": VaultReplicaSummary,
    "VaultSummary": VaultSummary,
    "VaultUsage": VaultUsage,
    "VerifiedData": VerifiedData,
    "VerifyDataDetails": VerifyDataDetails,
    "WrappedImportKey": WrappedImportKey,
    "WrappingKey": WrappingKey
}
