# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220901

from __future__ import absolute_import

from .artifact import Artifact
from .artifact_collection import ArtifactCollection
from .artifact_summary import ArtifactSummary
from .attachment import Attachment
from .attachment_collection import AttachmentCollection
from .attachment_summary import AttachmentSummary
from .buyer_information import BuyerInformation
from .category import Category
from .category_collection import CategoryCollection
from .category_summary import CategorySummary
from .change_artifact_compartment_details import ChangeArtifactCompartmentDetails
from .change_listing_compartment_details import ChangeListingCompartmentDetails
from .change_term_compartment_details import ChangeTermCompartmentDetails
from .contact import Contact
from .container_image_artifact import ContainerImageArtifact
from .container_image_details import ContainerImageDetails
from .container_package import ContainerPackage
from .create_artifact_details import CreateArtifactDetails
from .create_attachment_details import CreateAttachmentDetails
from .create_container_image_artifact_details import CreateContainerImageArtifactDetails
from .create_container_image_details import CreateContainerImageDetails
from .create_helm_chart_image_details import CreateHelmChartImageDetails
from .create_kubernetes_image_artifact_details import CreateKubernetesImageArtifactDetails
from .create_listing_details import CreateListingDetails
from .create_listing_revision_attachment_details import CreateListingRevisionAttachmentDetails
from .create_listing_revision_details import CreateListingRevisionDetails
from .create_listing_revision_note_details import CreateListingRevisionNoteDetails
from .create_listing_revision_package_details import CreateListingRevisionPackageDetails
from .create_offer_details import CreateOfferDetails
from .create_related_document_attachment_details import CreateRelatedDocumentAttachmentDetails
from .create_screen_shot_attachment_details import CreateScreenShotAttachmentDetails
from .create_term_details import CreateTermDetails
from .create_video_attachment_details import CreateVideoAttachmentDetails
from .create_video_details import CreateVideoDetails
from .custom_field import CustomField
from .helm_chart_image_details import HelmChartImageDetails
from .helm_chart_package import HelmChartPackage
from .kubernetes_image_artifact import KubernetesImageArtifact
from .language_item import LanguageItem
from .listing import Listing
from .listing_collection import ListingCollection
from .listing_revision import ListingRevision
from .listing_revision_attachment import ListingRevisionAttachment
from .listing_revision_attachment_collection import ListingRevisionAttachmentCollection
from .listing_revision_attachment_summary import ListingRevisionAttachmentSummary
from .listing_revision_collection import ListingRevisionCollection
from .listing_revision_icon_attachment import ListingRevisionIconAttachment
from .listing_revision_note import ListingRevisionNote
from .listing_revision_note_collection import ListingRevisionNoteCollection
from .listing_revision_note_summary import ListingRevisionNoteSummary
from .listing_revision_package import ListingRevisionPackage
from .listing_revision_package_collection import ListingRevisionPackageCollection
from .listing_revision_package_summary import ListingRevisionPackageSummary
from .listing_revision_summary import ListingRevisionSummary
from .listing_summary import ListingSummary
from .market import Market
from .market_collection import MarketCollection
from .market_summary import MarketSummary
from .named_link import NamedLink
from .offer import Offer
from .offer_collection import OfferCollection
from .offer_internal_detail import OfferInternalDetail
from .offer_summary import OfferSummary
from .opn_membership import OpnMembership
from .pricing import Pricing
from .private_offer_account_details import PrivateOfferAccountDetails
from .product import Product
from .product_collection import ProductCollection
from .product_summary import ProductSummary
from .publish_listing_revision_as_private_details import PublishListingRevisionAsPrivateDetails
from .publisher import Publisher
from .publisher_collection import PublisherCollection
from .publisher_summary import PublisherSummary
from .related_document_attachment import RelatedDocumentAttachment
from .resource_bundle import ResourceBundle
from .screen_shot_attachment import ScreenShotAttachment
from .seller_information import SellerInformation
from .submit_listing_revision_for_review_details import SubmitListingRevisionForReviewDetails
from .support_contact import SupportContact
from .term import Term
from .term_collection import TermCollection
from .term_summary import TermSummary
from .term_version import TermVersion
from .term_version_attachment import TermVersionAttachment
from .term_version_collection import TermVersionCollection
from .term_version_summary import TermVersionSummary
from .update_artifact_details import UpdateArtifactDetails
from .update_container_image_artifact_details import UpdateContainerImageArtifactDetails
from .update_container_image_details import UpdateContainerImageDetails
from .update_helm_chart_image_details import UpdateHelmChartImageDetails
from .update_kubernetes_image_artifact_details import UpdateKubernetesImageArtifactDetails
from .update_listing_details import UpdateListingDetails
from .update_listing_revision_attachment_details import UpdateListingRevisionAttachmentDetails
from .update_listing_revision_details import UpdateListingRevisionDetails
from .update_listing_revision_package_details import UpdateListingRevisionPackageDetails
from .update_offer_details import UpdateOfferDetails
from .update_related_document_attachment_details import UpdateRelatedDocumentAttachmentDetails
from .update_screen_shot_attachment_details import UpdateScreenShotAttachmentDetails
from .update_term_details import UpdateTermDetails
from .update_term_version_details import UpdateTermVersionDetails
from .update_video_attachment_details import UpdateVideoAttachmentDetails
from .upload_data import UploadData
from .version_details import VersionDetails
from .video_attachment import VideoAttachment
from .work_request import WorkRequest
from .work_request_error import WorkRequestError
from .work_request_error_collection import WorkRequestErrorCollection
from .work_request_log_entry import WorkRequestLogEntry
from .work_request_log_entry_collection import WorkRequestLogEntryCollection
from .work_request_resource import WorkRequestResource
from .work_request_summary import WorkRequestSummary
from .work_request_summary_collection import WorkRequestSummaryCollection

# Maps type names to classes for marketplace_publisher services.
marketplace_publisher_type_mapping = {
    "Artifact": Artifact,
    "ArtifactCollection": ArtifactCollection,
    "ArtifactSummary": ArtifactSummary,
    "Attachment": Attachment,
    "AttachmentCollection": AttachmentCollection,
    "AttachmentSummary": AttachmentSummary,
    "BuyerInformation": BuyerInformation,
    "Category": Category,
    "CategoryCollection": CategoryCollection,
    "CategorySummary": CategorySummary,
    "ChangeArtifactCompartmentDetails": ChangeArtifactCompartmentDetails,
    "ChangeListingCompartmentDetails": ChangeListingCompartmentDetails,
    "ChangeTermCompartmentDetails": ChangeTermCompartmentDetails,
    "Contact": Contact,
    "ContainerImageArtifact": ContainerImageArtifact,
    "ContainerImageDetails": ContainerImageDetails,
    "ContainerPackage": ContainerPackage,
    "CreateArtifactDetails": CreateArtifactDetails,
    "CreateAttachmentDetails": CreateAttachmentDetails,
    "CreateContainerImageArtifactDetails": CreateContainerImageArtifactDetails,
    "CreateContainerImageDetails": CreateContainerImageDetails,
    "CreateHelmChartImageDetails": CreateHelmChartImageDetails,
    "CreateKubernetesImageArtifactDetails": CreateKubernetesImageArtifactDetails,
    "CreateListingDetails": CreateListingDetails,
    "CreateListingRevisionAttachmentDetails": CreateListingRevisionAttachmentDetails,
    "CreateListingRevisionDetails": CreateListingRevisionDetails,
    "CreateListingRevisionNoteDetails": CreateListingRevisionNoteDetails,
    "CreateListingRevisionPackageDetails": CreateListingRevisionPackageDetails,
    "CreateOfferDetails": CreateOfferDetails,
    "CreateRelatedDocumentAttachmentDetails": CreateRelatedDocumentAttachmentDetails,
    "CreateScreenShotAttachmentDetails": CreateScreenShotAttachmentDetails,
    "CreateTermDetails": CreateTermDetails,
    "CreateVideoAttachmentDetails": CreateVideoAttachmentDetails,
    "CreateVideoDetails": CreateVideoDetails,
    "CustomField": CustomField,
    "HelmChartImageDetails": HelmChartImageDetails,
    "HelmChartPackage": HelmChartPackage,
    "KubernetesImageArtifact": KubernetesImageArtifact,
    "LanguageItem": LanguageItem,
    "Listing": Listing,
    "ListingCollection": ListingCollection,
    "ListingRevision": ListingRevision,
    "ListingRevisionAttachment": ListingRevisionAttachment,
    "ListingRevisionAttachmentCollection": ListingRevisionAttachmentCollection,
    "ListingRevisionAttachmentSummary": ListingRevisionAttachmentSummary,
    "ListingRevisionCollection": ListingRevisionCollection,
    "ListingRevisionIconAttachment": ListingRevisionIconAttachment,
    "ListingRevisionNote": ListingRevisionNote,
    "ListingRevisionNoteCollection": ListingRevisionNoteCollection,
    "ListingRevisionNoteSummary": ListingRevisionNoteSummary,
    "ListingRevisionPackage": ListingRevisionPackage,
    "ListingRevisionPackageCollection": ListingRevisionPackageCollection,
    "ListingRevisionPackageSummary": ListingRevisionPackageSummary,
    "ListingRevisionSummary": ListingRevisionSummary,
    "ListingSummary": ListingSummary,
    "Market": Market,
    "MarketCollection": MarketCollection,
    "MarketSummary": MarketSummary,
    "NamedLink": NamedLink,
    "Offer": Offer,
    "OfferCollection": OfferCollection,
    "OfferInternalDetail": OfferInternalDetail,
    "OfferSummary": OfferSummary,
    "OpnMembership": OpnMembership,
    "Pricing": Pricing,
    "PrivateOfferAccountDetails": PrivateOfferAccountDetails,
    "Product": Product,
    "ProductCollection": ProductCollection,
    "ProductSummary": ProductSummary,
    "PublishListingRevisionAsPrivateDetails": PublishListingRevisionAsPrivateDetails,
    "Publisher": Publisher,
    "PublisherCollection": PublisherCollection,
    "PublisherSummary": PublisherSummary,
    "RelatedDocumentAttachment": RelatedDocumentAttachment,
    "ResourceBundle": ResourceBundle,
    "ScreenShotAttachment": ScreenShotAttachment,
    "SellerInformation": SellerInformation,
    "SubmitListingRevisionForReviewDetails": SubmitListingRevisionForReviewDetails,
    "SupportContact": SupportContact,
    "Term": Term,
    "TermCollection": TermCollection,
    "TermSummary": TermSummary,
    "TermVersion": TermVersion,
    "TermVersionAttachment": TermVersionAttachment,
    "TermVersionCollection": TermVersionCollection,
    "TermVersionSummary": TermVersionSummary,
    "UpdateArtifactDetails": UpdateArtifactDetails,
    "UpdateContainerImageArtifactDetails": UpdateContainerImageArtifactDetails,
    "UpdateContainerImageDetails": UpdateContainerImageDetails,
    "UpdateHelmChartImageDetails": UpdateHelmChartImageDetails,
    "UpdateKubernetesImageArtifactDetails": UpdateKubernetesImageArtifactDetails,
    "UpdateListingDetails": UpdateListingDetails,
    "UpdateListingRevisionAttachmentDetails": UpdateListingRevisionAttachmentDetails,
    "UpdateListingRevisionDetails": UpdateListingRevisionDetails,
    "UpdateListingRevisionPackageDetails": UpdateListingRevisionPackageDetails,
    "UpdateOfferDetails": UpdateOfferDetails,
    "UpdateRelatedDocumentAttachmentDetails": UpdateRelatedDocumentAttachmentDetails,
    "UpdateScreenShotAttachmentDetails": UpdateScreenShotAttachmentDetails,
    "UpdateTermDetails": UpdateTermDetails,
    "UpdateTermVersionDetails": UpdateTermVersionDetails,
    "UpdateVideoAttachmentDetails": UpdateVideoAttachmentDetails,
    "UploadData": UploadData,
    "VersionDetails": VersionDetails,
    "VideoAttachment": VideoAttachment,
    "WorkRequest": WorkRequest,
    "WorkRequestError": WorkRequestError,
    "WorkRequestErrorCollection": WorkRequestErrorCollection,
    "WorkRequestLogEntry": WorkRequestLogEntry,
    "WorkRequestLogEntryCollection": WorkRequestLogEntryCollection,
    "WorkRequestResource": WorkRequestResource,
    "WorkRequestSummary": WorkRequestSummary,
    "WorkRequestSummaryCollection": WorkRequestSummaryCollection
}
