# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220901


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class UpdateListingRevisionAttachmentDetails(object):
    """
    Update the attachment for the listing revision.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new UpdateListingRevisionAttachmentDetails object with values from keyword arguments. This class has the following subclasses and if you are using this class as input
        to a service operations then you should favor using a subclass over the base class:

        * :class:`~oci.marketplace_publisher.models.UpdateScreenShotAttachmentDetails`
        * :class:`~oci.marketplace_publisher.models.UpdateRelatedDocumentAttachmentDetails`
        * :class:`~oci.marketplace_publisher.models.UpdateVideoAttachmentDetails`

        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param display_name:
            The value to assign to the display_name property of this UpdateListingRevisionAttachmentDetails.
        :type display_name: str

        :param description:
            The value to assign to the description property of this UpdateListingRevisionAttachmentDetails.
        :type description: str

        :param attachment_type:
            The value to assign to the attachment_type property of this UpdateListingRevisionAttachmentDetails.
        :type attachment_type: str

        :param freeform_tags:
            The value to assign to the freeform_tags property of this UpdateListingRevisionAttachmentDetails.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this UpdateListingRevisionAttachmentDetails.
        :type defined_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'display_name': 'str',
            'description': 'str',
            'attachment_type': 'str',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'display_name': 'displayName',
            'description': 'description',
            'attachment_type': 'attachmentType',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags'
        }

        self._display_name = None
        self._description = None
        self._attachment_type = None
        self._freeform_tags = None
        self._defined_tags = None

    @staticmethod
    def get_subtype(object_dictionary):
        """
        Given the hash representation of a subtype of this class,
        use the info in the hash to return the class of the subtype.
        """
        type = object_dictionary['attachmentType']

        if type == 'SCREENSHOT':
            return 'UpdateScreenShotAttachmentDetails'

        if type == 'RELATED_DOCUMENT':
            return 'UpdateRelatedDocumentAttachmentDetails'

        if type == 'VIDEO':
            return 'UpdateVideoAttachmentDetails'
        else:
            return 'UpdateListingRevisionAttachmentDetails'

    @property
    def display_name(self):
        """
        Gets the display_name of this UpdateListingRevisionAttachmentDetails.
        The name for the listing revision attachment.


        :return: The display_name of this UpdateListingRevisionAttachmentDetails.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this UpdateListingRevisionAttachmentDetails.
        The name for the listing revision attachment.


        :param display_name: The display_name of this UpdateListingRevisionAttachmentDetails.
        :type: str
        """
        self._display_name = display_name

    @property
    def description(self):
        """
        Gets the description of this UpdateListingRevisionAttachmentDetails.
        The description for the listing revision attachment.


        :return: The description of this UpdateListingRevisionAttachmentDetails.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this UpdateListingRevisionAttachmentDetails.
        The description for the listing revision attachment.


        :param description: The description of this UpdateListingRevisionAttachmentDetails.
        :type: str
        """
        self._description = description

    @property
    def attachment_type(self):
        """
        Gets the attachment_type of this UpdateListingRevisionAttachmentDetails.
        The specified attachment type for the listing revision attachment.


        :return: The attachment_type of this UpdateListingRevisionAttachmentDetails.
        :rtype: str
        """
        return self._attachment_type

    @attachment_type.setter
    def attachment_type(self, attachment_type):
        """
        Sets the attachment_type of this UpdateListingRevisionAttachmentDetails.
        The specified attachment type for the listing revision attachment.


        :param attachment_type: The attachment_type of this UpdateListingRevisionAttachmentDetails.
        :type: str
        """
        self._attachment_type = attachment_type

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this UpdateListingRevisionAttachmentDetails.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :return: The freeform_tags of this UpdateListingRevisionAttachmentDetails.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this UpdateListingRevisionAttachmentDetails.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :param freeform_tags: The freeform_tags of this UpdateListingRevisionAttachmentDetails.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this UpdateListingRevisionAttachmentDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :return: The defined_tags of this UpdateListingRevisionAttachmentDetails.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this UpdateListingRevisionAttachmentDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :param defined_tags: The defined_tags of this UpdateListingRevisionAttachmentDetails.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
