# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230701


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class SupportedVmwareSoftwareVersionSummary(object):
    """
    A specific version of bundled VMware software supported by the Oracle Cloud
    VMware Solution.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new SupportedVmwareSoftwareVersionSummary object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param version:
            The value to assign to the version property of this SupportedVmwareSoftwareVersionSummary.
        :type version: str

        :param description:
            The value to assign to the description property of this SupportedVmwareSoftwareVersionSummary.
        :type description: str

        :param esxi_software_versions:
            The value to assign to the esxi_software_versions property of this SupportedVmwareSoftwareVersionSummary.
        :type esxi_software_versions: list[oci.ocvp.models.SupportedEsxiSoftwareVersionSummary]

        """
        self.swagger_types = {
            'version': 'str',
            'description': 'str',
            'esxi_software_versions': 'list[SupportedEsxiSoftwareVersionSummary]'
        }

        self.attribute_map = {
            'version': 'version',
            'description': 'description',
            'esxi_software_versions': 'esxiSoftwareVersions'
        }

        self._version = None
        self._description = None
        self._esxi_software_versions = None

    @property
    def version(self):
        """
        **[Required]** Gets the version of this SupportedVmwareSoftwareVersionSummary.
        A short, unique string that identifies the version of bundled software.


        :return: The version of this SupportedVmwareSoftwareVersionSummary.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this SupportedVmwareSoftwareVersionSummary.
        A short, unique string that identifies the version of bundled software.


        :param version: The version of this SupportedVmwareSoftwareVersionSummary.
        :type: str
        """
        self._version = version

    @property
    def description(self):
        """
        **[Required]** Gets the description of this SupportedVmwareSoftwareVersionSummary.
        A description of the software in the bundle.


        :return: The description of this SupportedVmwareSoftwareVersionSummary.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this SupportedVmwareSoftwareVersionSummary.
        A description of the software in the bundle.


        :param description: The description of this SupportedVmwareSoftwareVersionSummary.
        :type: str
        """
        self._description = description

    @property
    def esxi_software_versions(self):
        """
        Gets the esxi_software_versions of this SupportedVmwareSoftwareVersionSummary.
        A list of supported ESXi software versions.


        :return: The esxi_software_versions of this SupportedVmwareSoftwareVersionSummary.
        :rtype: list[oci.ocvp.models.SupportedEsxiSoftwareVersionSummary]
        """
        return self._esxi_software_versions

    @esxi_software_versions.setter
    def esxi_software_versions(self, esxi_software_versions):
        """
        Sets the esxi_software_versions of this SupportedVmwareSoftwareVersionSummary.
        A list of supported ESXi software versions.


        :param esxi_software_versions: The esxi_software_versions of this SupportedVmwareSoftwareVersionSummary.
        :type: list[oci.ocvp.models.SupportedEsxiSoftwareVersionSummary]
        """
        self._esxi_software_versions = esxi_software_versions

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
