# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20180828

from __future__ import absolute_import

from .backup_event_details import BackupEventDetails
from .backup_opensearch_cluster_details import BackupOpensearchClusterDetails
from .backup_policy import BackupPolicy
from .benchmark_details import BenchmarkDetails
from .change_opensearch_cluster_backup_compartment_details import ChangeOpensearchClusterBackupCompartmentDetails
from .change_opensearch_cluster_compartment_details import ChangeOpensearchClusterCompartmentDetails
from .configure_outbound_cluster_details import ConfigureOutboundClusterDetails
from .create_maintenance_details import CreateMaintenanceDetails
from .create_opensearch_cluster_details import CreateOpensearchClusterDetails
from .create_opensearch_cluster_pipeline_details import CreateOpensearchClusterPipelineDetails
from .customer_logging_details import CustomerLoggingDetails
from .delete_block_volumes_for_namespace_details import DeleteBlockVolumesForNamespaceDetails
from .export_opensearch_cluster_backup_details import ExportOpensearchClusterBackupDetails
from .force_patch_cluster_details import ForcePatchClusterDetails
from .get_manifest_response import GetManifestResponse
from .maintenance_details import MaintenanceDetails
from .maintenance_notification_details import MaintenanceNotificationDetails
from .maintenance_notification_failure import MaintenanceNotificationFailure
from .maintenance_notification_response import MaintenanceNotificationResponse
from .opensearch_cluster import OpensearchCluster
from .opensearch_cluster_backup import OpensearchClusterBackup
from .opensearch_cluster_backup_collection import OpensearchClusterBackupCollection
from .opensearch_cluster_backup_summary import OpensearchClusterBackupSummary
from .opensearch_cluster_collection import OpensearchClusterCollection
from .opensearch_cluster_internal_details import OpensearchClusterInternalDetails
from .opensearch_cluster_pipeline import OpensearchClusterPipeline
from .opensearch_cluster_pipeline_collection import OpensearchClusterPipelineCollection
from .opensearch_cluster_pipeline_summary import OpensearchClusterPipelineSummary
from .opensearch_cluster_summary import OpensearchClusterSummary
from .opensearch_pipeline_validation_response import OpensearchPipelineValidationResponse
from .opensearch_versions_collection import OpensearchVersionsCollection
from .opensearch_versions_summary import OpensearchVersionsSummary
from .outbound_cluster_config import OutboundClusterConfig
from .outbound_cluster_summary import OutboundClusterSummary
from .pipeline_validation_error_details import PipelineValidationErrorDetails
from .reclaim_cluster_details import ReclaimClusterDetails
from .resize_opensearch_cluster_horizontal_details import ResizeOpensearchClusterHorizontalDetails
from .resize_opensearch_cluster_vertical_details import ResizeOpensearchClusterVerticalDetails
from .restore_opensearch_cluster_backup_details import RestoreOpensearchClusterBackupDetails
from .restore_opensearch_cluster_details import RestoreOpensearchClusterDetails
from .reverse_connection_endpoint import ReverseConnectionEndpoint
from .security_saml_config import SecuritySamlConfig
from .update_checkin_details import UpdateCheckinDetails
from .update_cluster_hardened_image_details import UpdateClusterHardenedImageDetails
from .update_cluster_specs_details import UpdateClusterSpecsDetails
from .update_cluster_status_details import UpdateClusterStatusDetails
from .update_maintenance_details import UpdateMaintenanceDetails
from .update_opensearch_cluster_backup_details import UpdateOpensearchClusterBackupDetails
from .update_opensearch_cluster_details import UpdateOpensearchClusterDetails
from .update_opensearch_cluster_pipeline_details import UpdateOpensearchClusterPipelineDetails
from .upgrade_open_search_cluster_details import UpgradeOpenSearchClusterDetails
from .validate_opensearch_pipeline_details import ValidateOpensearchPipelineDetails
from .work_request import WorkRequest
from .work_request_collection import WorkRequestCollection
from .work_request_error import WorkRequestError
from .work_request_error_collection import WorkRequestErrorCollection
from .work_request_log_entry import WorkRequestLogEntry
from .work_request_log_entry_collection import WorkRequestLogEntryCollection
from .work_request_resource import WorkRequestResource

# Maps type names to classes for opensearch services.
opensearch_type_mapping = {
    "BackupEventDetails": BackupEventDetails,
    "BackupOpensearchClusterDetails": BackupOpensearchClusterDetails,
    "BackupPolicy": BackupPolicy,
    "BenchmarkDetails": BenchmarkDetails,
    "ChangeOpensearchClusterBackupCompartmentDetails": ChangeOpensearchClusterBackupCompartmentDetails,
    "ChangeOpensearchClusterCompartmentDetails": ChangeOpensearchClusterCompartmentDetails,
    "ConfigureOutboundClusterDetails": ConfigureOutboundClusterDetails,
    "CreateMaintenanceDetails": CreateMaintenanceDetails,
    "CreateOpensearchClusterDetails": CreateOpensearchClusterDetails,
    "CreateOpensearchClusterPipelineDetails": CreateOpensearchClusterPipelineDetails,
    "CustomerLoggingDetails": CustomerLoggingDetails,
    "DeleteBlockVolumesForNamespaceDetails": DeleteBlockVolumesForNamespaceDetails,
    "ExportOpensearchClusterBackupDetails": ExportOpensearchClusterBackupDetails,
    "ForcePatchClusterDetails": ForcePatchClusterDetails,
    "GetManifestResponse": GetManifestResponse,
    "MaintenanceDetails": MaintenanceDetails,
    "MaintenanceNotificationDetails": MaintenanceNotificationDetails,
    "MaintenanceNotificationFailure": MaintenanceNotificationFailure,
    "MaintenanceNotificationResponse": MaintenanceNotificationResponse,
    "OpensearchCluster": OpensearchCluster,
    "OpensearchClusterBackup": OpensearchClusterBackup,
    "OpensearchClusterBackupCollection": OpensearchClusterBackupCollection,
    "OpensearchClusterBackupSummary": OpensearchClusterBackupSummary,
    "OpensearchClusterCollection": OpensearchClusterCollection,
    "OpensearchClusterInternalDetails": OpensearchClusterInternalDetails,
    "OpensearchClusterPipeline": OpensearchClusterPipeline,
    "OpensearchClusterPipelineCollection": OpensearchClusterPipelineCollection,
    "OpensearchClusterPipelineSummary": OpensearchClusterPipelineSummary,
    "OpensearchClusterSummary": OpensearchClusterSummary,
    "OpensearchPipelineValidationResponse": OpensearchPipelineValidationResponse,
    "OpensearchVersionsCollection": OpensearchVersionsCollection,
    "OpensearchVersionsSummary": OpensearchVersionsSummary,
    "OutboundClusterConfig": OutboundClusterConfig,
    "OutboundClusterSummary": OutboundClusterSummary,
    "PipelineValidationErrorDetails": PipelineValidationErrorDetails,
    "ReclaimClusterDetails": ReclaimClusterDetails,
    "ResizeOpensearchClusterHorizontalDetails": ResizeOpensearchClusterHorizontalDetails,
    "ResizeOpensearchClusterVerticalDetails": ResizeOpensearchClusterVerticalDetails,
    "RestoreOpensearchClusterBackupDetails": RestoreOpensearchClusterBackupDetails,
    "RestoreOpensearchClusterDetails": RestoreOpensearchClusterDetails,
    "ReverseConnectionEndpoint": ReverseConnectionEndpoint,
    "SecuritySamlConfig": SecuritySamlConfig,
    "UpdateCheckinDetails": UpdateCheckinDetails,
    "UpdateClusterHardenedImageDetails": UpdateClusterHardenedImageDetails,
    "UpdateClusterSpecsDetails": UpdateClusterSpecsDetails,
    "UpdateClusterStatusDetails": UpdateClusterStatusDetails,
    "UpdateMaintenanceDetails": UpdateMaintenanceDetails,
    "UpdateOpensearchClusterBackupDetails": UpdateOpensearchClusterBackupDetails,
    "UpdateOpensearchClusterDetails": UpdateOpensearchClusterDetails,
    "UpdateOpensearchClusterPipelineDetails": UpdateOpensearchClusterPipelineDetails,
    "UpgradeOpenSearchClusterDetails": UpgradeOpenSearchClusterDetails,
    "ValidateOpensearchPipelineDetails": ValidateOpensearchPipelineDetails,
    "WorkRequest": WorkRequest,
    "WorkRequestCollection": WorkRequestCollection,
    "WorkRequestError": WorkRequestError,
    "WorkRequestErrorCollection": WorkRequestErrorCollection,
    "WorkRequestLogEntry": WorkRequestLogEntry,
    "WorkRequestLogEntryCollection": WorkRequestLogEntryCollection,
    "WorkRequestResource": WorkRequestResource
}
