# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20180828


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class OpensearchClusterPipelineSummary(object):
    """
    The summary of information about an OpenSearch cluster Pipeline.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new OpensearchClusterPipelineSummary object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param id:
            The value to assign to the id property of this OpensearchClusterPipelineSummary.
        :type id: str

        :param display_name:
            The value to assign to the display_name property of this OpensearchClusterPipelineSummary.
        :type display_name: str

        :param compartment_id:
            The value to assign to the compartment_id property of this OpensearchClusterPipelineSummary.
        :type compartment_id: str

        :param max_ocpu_count:
            The value to assign to the max_ocpu_count property of this OpensearchClusterPipelineSummary.
        :type max_ocpu_count: int

        :param min_ocpu_count:
            The value to assign to the min_ocpu_count property of this OpensearchClusterPipelineSummary.
        :type min_ocpu_count: int

        :param max_memory_gb:
            The value to assign to the max_memory_gb property of this OpensearchClusterPipelineSummary.
        :type max_memory_gb: int

        :param min_memory_gb:
            The value to assign to the min_memory_gb property of this OpensearchClusterPipelineSummary.
        :type min_memory_gb: int

        :param pipeline_configuration_body:
            The value to assign to the pipeline_configuration_body property of this OpensearchClusterPipelineSummary.
        :type pipeline_configuration_body: str

        :param time_created:
            The value to assign to the time_created property of this OpensearchClusterPipelineSummary.
        :type time_created: datetime

        :param time_updated:
            The value to assign to the time_updated property of this OpensearchClusterPipelineSummary.
        :type time_updated: datetime

        :param lifecycle_state:
            The value to assign to the lifecycle_state property of this OpensearchClusterPipelineSummary.
        :type lifecycle_state: str

        :param freeform_tags:
            The value to assign to the freeform_tags property of this OpensearchClusterPipelineSummary.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this OpensearchClusterPipelineSummary.
        :type defined_tags: dict(str, dict(str, object))

        :param system_tags:
            The value to assign to the system_tags property of this OpensearchClusterPipelineSummary.
        :type system_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'id': 'str',
            'display_name': 'str',
            'compartment_id': 'str',
            'max_ocpu_count': 'int',
            'min_ocpu_count': 'int',
            'max_memory_gb': 'int',
            'min_memory_gb': 'int',
            'pipeline_configuration_body': 'str',
            'time_created': 'datetime',
            'time_updated': 'datetime',
            'lifecycle_state': 'str',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))',
            'system_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'id': 'id',
            'display_name': 'displayName',
            'compartment_id': 'compartmentId',
            'max_ocpu_count': 'maxOcpuCount',
            'min_ocpu_count': 'minOcpuCount',
            'max_memory_gb': 'maxMemoryGB',
            'min_memory_gb': 'minMemoryGB',
            'pipeline_configuration_body': 'pipelineConfigurationBody',
            'time_created': 'timeCreated',
            'time_updated': 'timeUpdated',
            'lifecycle_state': 'lifecycleState',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags',
            'system_tags': 'systemTags'
        }

        self._id = None
        self._display_name = None
        self._compartment_id = None
        self._max_ocpu_count = None
        self._min_ocpu_count = None
        self._max_memory_gb = None
        self._min_memory_gb = None
        self._pipeline_configuration_body = None
        self._time_created = None
        self._time_updated = None
        self._lifecycle_state = None
        self._freeform_tags = None
        self._defined_tags = None
        self._system_tags = None

    @property
    def id(self):
        """
        **[Required]** Gets the id of this OpensearchClusterPipelineSummary.
        The OCID of the cluster pipeline.


        :return: The id of this OpensearchClusterPipelineSummary.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this OpensearchClusterPipelineSummary.
        The OCID of the cluster pipeline.


        :param id: The id of this OpensearchClusterPipelineSummary.
        :type: str
        """
        self._id = id

    @property
    def display_name(self):
        """
        Gets the display_name of this OpensearchClusterPipelineSummary.
        The name of the cluster pipeline. Avoid entering confidential information.


        :return: The display_name of this OpensearchClusterPipelineSummary.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this OpensearchClusterPipelineSummary.
        The name of the cluster pipeline. Avoid entering confidential information.


        :param display_name: The display_name of this OpensearchClusterPipelineSummary.
        :type: str
        """
        self._display_name = display_name

    @property
    def compartment_id(self):
        """
        **[Required]** Gets the compartment_id of this OpensearchClusterPipelineSummary.
        The OCID of the compartment where the cluster pipeline is located.


        :return: The compartment_id of this OpensearchClusterPipelineSummary.
        :rtype: str
        """
        return self._compartment_id

    @compartment_id.setter
    def compartment_id(self, compartment_id):
        """
        Sets the compartment_id of this OpensearchClusterPipelineSummary.
        The OCID of the compartment where the cluster pipeline is located.


        :param compartment_id: The compartment_id of this OpensearchClusterPipelineSummary.
        :type: str
        """
        self._compartment_id = compartment_id

    @property
    def max_ocpu_count(self):
        """
        **[Required]** Gets the max_ocpu_count of this OpensearchClusterPipelineSummary.
        The maximum pipeline capacity, in OCPUs.


        :return: The max_ocpu_count of this OpensearchClusterPipelineSummary.
        :rtype: int
        """
        return self._max_ocpu_count

    @max_ocpu_count.setter
    def max_ocpu_count(self, max_ocpu_count):
        """
        Sets the max_ocpu_count of this OpensearchClusterPipelineSummary.
        The maximum pipeline capacity, in OCPUs.


        :param max_ocpu_count: The max_ocpu_count of this OpensearchClusterPipelineSummary.
        :type: int
        """
        self._max_ocpu_count = max_ocpu_count

    @property
    def min_ocpu_count(self):
        """
        **[Required]** Gets the min_ocpu_count of this OpensearchClusterPipelineSummary.
        The maximum pipeline capacity, in OCPUs.


        :return: The min_ocpu_count of this OpensearchClusterPipelineSummary.
        :rtype: int
        """
        return self._min_ocpu_count

    @min_ocpu_count.setter
    def min_ocpu_count(self, min_ocpu_count):
        """
        Sets the min_ocpu_count of this OpensearchClusterPipelineSummary.
        The maximum pipeline capacity, in OCPUs.


        :param min_ocpu_count: The min_ocpu_count of this OpensearchClusterPipelineSummary.
        :type: int
        """
        self._min_ocpu_count = min_ocpu_count

    @property
    def max_memory_gb(self):
        """
        **[Required]** Gets the max_memory_gb of this OpensearchClusterPipelineSummary.
        The maximum amount of memory in GB, for the pipeline.


        :return: The max_memory_gb of this OpensearchClusterPipelineSummary.
        :rtype: int
        """
        return self._max_memory_gb

    @max_memory_gb.setter
    def max_memory_gb(self, max_memory_gb):
        """
        Sets the max_memory_gb of this OpensearchClusterPipelineSummary.
        The maximum amount of memory in GB, for the pipeline.


        :param max_memory_gb: The max_memory_gb of this OpensearchClusterPipelineSummary.
        :type: int
        """
        self._max_memory_gb = max_memory_gb

    @property
    def min_memory_gb(self):
        """
        **[Required]** Gets the min_memory_gb of this OpensearchClusterPipelineSummary.
        The minimum amount of memory in GB, for the pipeline.


        :return: The min_memory_gb of this OpensearchClusterPipelineSummary.
        :rtype: int
        """
        return self._min_memory_gb

    @min_memory_gb.setter
    def min_memory_gb(self, min_memory_gb):
        """
        Sets the min_memory_gb of this OpensearchClusterPipelineSummary.
        The minimum amount of memory in GB, for the pipeline.


        :param min_memory_gb: The min_memory_gb of this OpensearchClusterPipelineSummary.
        :type: int
        """
        self._min_memory_gb = min_memory_gb

    @property
    def pipeline_configuration_body(self):
        """
        **[Required]** Gets the pipeline_configuration_body of this OpensearchClusterPipelineSummary.
        The pipeline configuration in YAML format. The command accepts the pipeline configuration as a string or within a .yaml file. If you provide the configuration as a string, each new line must be escaped with \\.


        :return: The pipeline_configuration_body of this OpensearchClusterPipelineSummary.
        :rtype: str
        """
        return self._pipeline_configuration_body

    @pipeline_configuration_body.setter
    def pipeline_configuration_body(self, pipeline_configuration_body):
        """
        Sets the pipeline_configuration_body of this OpensearchClusterPipelineSummary.
        The pipeline configuration in YAML format. The command accepts the pipeline configuration as a string or within a .yaml file. If you provide the configuration as a string, each new line must be escaped with \\.


        :param pipeline_configuration_body: The pipeline_configuration_body of this OpensearchClusterPipelineSummary.
        :type: str
        """
        self._pipeline_configuration_body = pipeline_configuration_body

    @property
    def time_created(self):
        """
        Gets the time_created of this OpensearchClusterPipelineSummary.
        The date and time the cluster pipeline was created. Format defined by `RFC3339`__.

        __ https://tools.ietf.org/html/rfc3339


        :return: The time_created of this OpensearchClusterPipelineSummary.
        :rtype: datetime
        """
        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this OpensearchClusterPipelineSummary.
        The date and time the cluster pipeline was created. Format defined by `RFC3339`__.

        __ https://tools.ietf.org/html/rfc3339


        :param time_created: The time_created of this OpensearchClusterPipelineSummary.
        :type: datetime
        """
        self._time_created = time_created

    @property
    def time_updated(self):
        """
        Gets the time_updated of this OpensearchClusterPipelineSummary.
        The date and time the cluster pipeline was updated. Format defined by `RFC3339`__.

        __ https://tools.ietf.org/html/rfc3339


        :return: The time_updated of this OpensearchClusterPipelineSummary.
        :rtype: datetime
        """
        return self._time_updated

    @time_updated.setter
    def time_updated(self, time_updated):
        """
        Sets the time_updated of this OpensearchClusterPipelineSummary.
        The date and time the cluster pipeline was updated. Format defined by `RFC3339`__.

        __ https://tools.ietf.org/html/rfc3339


        :param time_updated: The time_updated of this OpensearchClusterPipelineSummary.
        :type: datetime
        """
        self._time_updated = time_updated

    @property
    def lifecycle_state(self):
        """
        **[Required]** Gets the lifecycle_state of this OpensearchClusterPipelineSummary.
        The current state of the cluster backup.


        :return: The lifecycle_state of this OpensearchClusterPipelineSummary.
        :rtype: str
        """
        return self._lifecycle_state

    @lifecycle_state.setter
    def lifecycle_state(self, lifecycle_state):
        """
        Sets the lifecycle_state of this OpensearchClusterPipelineSummary.
        The current state of the cluster backup.


        :param lifecycle_state: The lifecycle_state of this OpensearchClusterPipelineSummary.
        :type: str
        """
        self._lifecycle_state = lifecycle_state

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this OpensearchClusterPipelineSummary.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :return: The freeform_tags of this OpensearchClusterPipelineSummary.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this OpensearchClusterPipelineSummary.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :param freeform_tags: The freeform_tags of this OpensearchClusterPipelineSummary.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this OpensearchClusterPipelineSummary.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :return: The defined_tags of this OpensearchClusterPipelineSummary.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this OpensearchClusterPipelineSummary.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :param defined_tags: The defined_tags of this OpensearchClusterPipelineSummary.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    @property
    def system_tags(self):
        """
        Gets the system_tags of this OpensearchClusterPipelineSummary.
        Usage of system tag keys. These predefined keys are scoped to namespaces.
        Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`


        :return: The system_tags of this OpensearchClusterPipelineSummary.
        :rtype: dict(str, dict(str, object))
        """
        return self._system_tags

    @system_tags.setter
    def system_tags(self, system_tags):
        """
        Sets the system_tags of this OpensearchClusterPipelineSummary.
        Usage of system tag keys. These predefined keys are scoped to namespaces.
        Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`


        :param system_tags: The system_tags of this OpensearchClusterPipelineSummary.
        :type: dict(str, dict(str, object))
        """
        self._system_tags = system_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
