# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20180828


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class OpensearchPipelineValidationResponse(object):
    """
    Details for validation of customer input pipeline configuration.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new OpensearchPipelineValidationResponse object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param errors:
            The value to assign to the errors property of this OpensearchPipelineValidationResponse.
        :type errors: list[oci.opensearch.models.PipelineValidationErrorDetails]

        :param is_valid:
            The value to assign to the is_valid property of this OpensearchPipelineValidationResponse.
        :type is_valid: bool

        """
        self.swagger_types = {
            'errors': 'list[PipelineValidationErrorDetails]',
            'is_valid': 'bool'
        }

        self.attribute_map = {
            'errors': 'errors',
            'is_valid': 'isValid'
        }

        self._errors = None
        self._is_valid = None

    @property
    def errors(self):
        """
        **[Required]** Gets the errors of this OpensearchPipelineValidationResponse.
        An array of errors in the pipeline configuration which is given for validation.


        :return: The errors of this OpensearchPipelineValidationResponse.
        :rtype: list[oci.opensearch.models.PipelineValidationErrorDetails]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """
        Sets the errors of this OpensearchPipelineValidationResponse.
        An array of errors in the pipeline configuration which is given for validation.


        :param errors: The errors of this OpensearchPipelineValidationResponse.
        :type: list[oci.opensearch.models.PipelineValidationErrorDetails]
        """
        self._errors = errors

    @property
    def is_valid(self):
        """
        **[Required]** Gets the is_valid of this OpensearchPipelineValidationResponse.
        Boolean value which tells us if the pipeline configuration given by user is valid or not.


        :return: The is_valid of this OpensearchPipelineValidationResponse.
        :rtype: bool
        """
        return self._is_valid

    @is_valid.setter
    def is_valid(self, is_valid):
        """
        Sets the is_valid of this OpensearchPipelineValidationResponse.
        Boolean value which tells us if the pipeline configuration given by user is valid or not.


        :param is_valid: The is_valid of this OpensearchPipelineValidationResponse.
        :type: bool
        """
        self._is_valid = is_valid

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
